#include <stdio.h>

#define FIM 0
#define HABITANTES 501

void mflush(void);
float calc_salarioMedio (float []);
int calc_mulheres (int [], float [], char []);
float calc_idades (int [], int *, int *);

/***************************
 * Programa principal
 ***************************
 */

int main (void) 
{

  float salario[HABITANTES],
        idade_media;
  int idade[HABITANTES], id,
      filhos[HABITANTES],
      idade_max,
      idade_min;
  char sexo[HABITANTES];
  int hab = 0;

  do {
    printf ("Entre dados do habitante:\n");
    printf ("\t idade: ");
    scanf ("%d", &id);
    mflush();
    if (id != FIM) { 
      idade[hab] = id;
      printf ("\t sexo: ");
      scanf ("%c", &sexo[hab]);
      if (sexo[hab] != 'f' && sexo[hab] != 'F' && 
	  sexo[hab] != 'm' && sexo[hab] != 'M') {
	printf ("\t\t Sexo deve ser M, m, F ou f\n");
	mflush();
	continue;
      }
      printf ("\t salario: ");
      scanf ("%f", &salario[hab]);
      printf ("\t filhos: ");
      scanf ("%d", &filhos[hab]);
      hab++;
    }
  } while (id != FIM && hab < HABITANTES);

  idade[hab] = sexo[hab] = salario[hab] = filhos[hab] = -1;

  if (hab) {
    idade_media = calc_idades(idade, &idade_max, &idade_min);

    printf ("MEDIA SALARIAL = %f\n", calc_salarioMedio (salario));
    printf ("IDADES: max = %d, min = %d, media = %f\n", 
	    idade_max, idade_min, idade_media);
    printf ("Mulheres com 3 filhos e renda ate' R$500,00 = %d\n", 
	    calc_mulheres(filhos, salario, sexo));
  }
}

/**********************************************************************
 *  Funcao calc_salarioMedio
 * 
 *  Acao:       Calcula salario medio de um conjunto de habitantes de
 *              uma cidade
 *  Entrada:    vetor com todos os salarios coletados
 *  Saida:      salario medio
 *  Suposicoes: Ultimo elemento do vetor tem valor -1, que deve ser
 *              desconsiderado no calculo da media
 *  Algoritmo:  Soma todos os elementos do vetor (exceto o ultimo) e
 *              divide o resultado pelo numero de elementos
 **********************************************************************
 */
float calc_salarioMedio (float sal [])
{
  float media = 0;
  int i;
  
  for (i = 0; sal[i] != -1; i++) 
    media += sal[i];

  return (media / i);

}

/**********************************************************************
 *  Funcao calc_idades
 * 
 *  Acao:       Calcula idade media, maxima e minima de um conjunto de
 *              habitantes de uma cidade
 *  Entrada:    vetor com as idades coletadas
 *  Saida:      salario medio (retorno)
 *              idade maxima e minima (por referencia)
 *  Suposicoes: Ultimo elemento do vetor tem valor -1, que deve ser
 *              desconsiderado nos calculos
 *  Algoritmo:  Soma todos os elementos do vetor (exceto o ultimo) e
 *              divide o resultado pelo numero de elementos.
 *              Enquanto soma, calcula maior e menor idade.
 **********************************************************************
 */
float calc_idades (int id [], int *max, int *min)
{
  float media;
  int i;

  for (media = i = 0, *max = *min = id[0]; id[i] != -1; i++) {
    media += id[i];

    if (*max < id[i]) 
      *max = id[i];
    else if (*min > id[i])
      *min = id[i];
  }

  return (media / i);

}

/**********************************************************************
 *  Funcao calc_mulheres
 * 
 *  Acao:       Calcula quantidade de mulheres com 3 filhos e salario
 *              ateh R$ 500,00
 *  Entrada:    vetores com numero de filhos, salarios e sexos
 *              coletados
 *  Saida:      quantidade de mulheres que obedecem aos criterios.
 *  Suposicoes: Ultimo elemento de cada vetor tem valor -1, que deve
 *              ser desconsiderado nos calculos
 **********************************************************************
 */
int calc_mulheres (int filhos [], float sal [], char sexo [])
{
  int i,
      mulheres;

  for (mulheres = i = 0; filhos[i] != -1; i++) {
    if ((sexo[i] == 'F' || sexo[i] == 'f') && 
	filhos[i] == 3 && sal[i] <= 500.00)
      ++mulheres;
  }

  return mulheres;
}

/**********************************************************************
 *  Funcao mflush
 * 
 *  Acao:       esvazia buffer de entrada
 *  Entrada:    nenhuma
 *  Saida:      nenhuma
 **********************************************************************
 */
void mflush()
{
  while (getchar() != '\n');
}

